# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- test
- build

sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml

# Publish to PyPI using Poetry with credentials from Vault Secrets.
# Environment variables for Vault Secrets access:
# HCP_CLIENT_ID, HCP_CLIENT_SECRET, VLT_APPLICATION_NAME, VLT_ORGANIZATION_ID, VLT_PROJECT_ID 
image: ubuntu
pypi_publish:
  stage: build

  rules:
    # Only run on the default branch.
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

  script:
    # Install prerequisites.
    - |
      apt update 
      apt install -y python3 python3-pip gpg wget lsb-release
      python3 -m pip install --upgrade pip
      python3 -m pip install poetry

    # Install Vault Secrets CLI.
    - >
      wget -O- https://apt.releases.hashicorp.com/gpg 
      | gpg --dearmor -o /usr/share/keyrings/hashicorp-archive-keyring.gpg

      echo 
      "deb [arch=$(dpkg --print-architecture) 
      signed-by=/usr/share/keyrings/hashicorp-archive-keyring.gpg] 
      https://apt.releases.hashicorp.com $(lsb_release -cs) main" 
      | tee /etc/apt/sources.list.d/hashicorp.list

      apt update && apt install -y vlt

    # Build the project, supplying credentials from Vault Secrets.
    - vlt run --command "bash ./build.sh"
